import base64

NAME = 'Cessfull'

ART = 'art-default.jpg'
ICON = 'icon-default.png'

API_URL = 'https://www.cessfull.com/api/v1'
AUTHENTICATION_URL = 'https://www.cessfull.com/api/v1/connect/token/'

####################################################################################################
def ValidatePrefs():
    Authenticate()

####################################################################################################
def Authenticate():
    Log.Debug("Authenticate")
    if Prefs['email'] and Prefs['password']:
        try:
            Log.Debug("Attempting cessfull authentication")
            base64string = base64.encodestring('%s:%s' % (Prefs['email'], Prefs['password'])).replace('\n', '')
            auth = JSON.ObjectFromURL(AUTHENTICATION_URL, 
                headers=dict(authorization="Basic %s" % base64string))
            Log.Info("Login Successful")
            Dict['api_key'] = auth['key'];
            return True
        except Ex.HTTPError, e:
            Log.Error(e.content)
            Log.Error('Login Failed')
            return False
        except:
            Log.Error('Login Failed')
            return False
    else:
        return False

def listfolder(id_parent='/'):
    response = JSON.ObjectFromURL(API_URL+'/files/?id_parent=%s&username=%s&api_key=%s' % (id_parent, Prefs['email'], Dict['api_key']) )
    files = response['items']
    return files
        
def Start():
    Plugin.AddViewGroup('InfoList', viewMode = 'InfoList', mediaType = 'items')
    Plugin.AddViewGroup('List', viewMode = 'List', mediaType = 'items')
    Plugin.AddViewGroup('Photos', viewMode = 'List', mediaType = 'photos')
    
    ObjectContainer.art = R(ART)
    ObjectContainer.title1 = NAME
    
    DirectoryItem.thumb = R(ICON)
    Authenticate()

@handler('/video/cessfull', NAME, art=ART, thumb=ICON)
def MainMenu():
    return ParseDirectory('/', NAME)


@route('/video/cessfull/directory/{id}')
def ParseDirectory(path, name):
    oc = ObjectContainer(title1=name, view_group='InfoList')

    oc.add(PrefsObject(title = L('Preferences')))

    response = listfolder(path)
    Log.Debug(response)
    for f in response:
        if f['content_type'] == 'folder':
            oc.add(DirectoryObject(
                key = Callback(ParseDirectory, path = f['id_parent'], name = f['name']),
                title = f['name']))
        
        elif f['content_type'].startswith('video'):
            oc.add(VideoClipObject(
                key = Callback(Lookup, path = f['id_parent'], name= name, content_type=f['content_type'], id=f['id'], link=f['urldl']),
                items = [ MediaObject(parts = [ PartObject(key = Callback(PlayMedia, url = f['urldl'])) ]) ],
                rating_key = f['id'],
                title = f['name'],
                thumb = False))
        
        elif f['content_type'].startswith('audio'):
            oc.add(TrackObject(
                key = Callback(Lookup, path = f['id_parent'], name= name, content_type=f['content_type'], id=f['id'], link=f['urldl']),
                items = [ MediaObject(parts = [ PartObject(key = Callback(PlayMedia, url = f['urldl'])) ]) ],
                rating_key = f['id'],
                title = f['name'],
                thumb = False))
        
        else:
            Log.Info("Unsupported content type '%s'" % f['content_type'])

    return oc


@route('/video/cessfull/lookup')
def Lookup(path, name, id, link, content_type):
    oc = ObjectContainer()
        
    if content_type.startswith('video'):
        oc.add(VideoClipObject(
            key = Callback(Lookup, path=path, name=name, link=link, id=id, content_type=content_type),
            items = [ MediaObject(parts = [ PartObject(key = Callback(PlayMedia, url = link)) ]) ],
            rating_key = id,
            title = name,
            thumb = False))
    
    elif content_type.startswith('audio'):
        oc.add(TrackObject(
            key = Callback(Lookup, path=path, name=name, link=link, id=id, content_type=content_type),
            items = [ MediaObject(parts = [ PartObject(key = Callback(PlayMedia, url = link)) ]) ],
            rating_key = id,
            title = name,
            thumb = False))
    
    else:
        Log.Info("Unsupported content type '%s'" % content_type)
    
    return oc


@route('/video/cessfull/play')
def PlayMedia(url):
    return Redirect(url)

